/*************************************************************************
*  File:        MEM.C                                                    *
*  Purpose:     COMTROL Hostess i Programmer's Toolkit Memory Allocation *
*       Functions                                                        *
*  Date:        September 19, 1990                                       *
*  Author:      Howard D. Straus                                         *
*  Release:     1.00 - Original release                                  *
**************************************************************************
*                         COPYRIGHT NOTICE                            *
*=====================================================================*
*   Copyright 1990, 1991 by Howard D. Straus and Comtrol Corporation. *
*   All rights reserved.  Use or reproduction by any means of any     *
*   portion of this code contrary to the developers license agreement *
*   is expressly prohibited.                                          *
***********************************************************************/

#include "compiler.h"

#include <dos.h>

#include "hostess.h"
#include "proto.h"
#include "externs.h"

unsigned int    low_bound = FIRST_FREE_MEMORY; /* first available memory */

/*
        return amount of memory remaining in segment 0
*/
unsigned int
memavail()
{
        return(HIGH_BOUND - low_bound);
}


/*
        allocate a block of memory from segment 0
*/
void    far     *
memalloc(l)
        unsigned int    l;              /* amount of memory requested */
{   void    far     *rp;            /* return pointer */

        if (memavail() < l)             /* not enough memory available */
                return((void far *)NULL);   /* return NULL indication */

        rp = MK_FP(0, low_bound);       /* construct far pointer in seg 0 */
        low_bound += l;                 /* remove memory from availability */
        return(rp);                     /* return address */
}


                                        /* ***** END OF FILE ***** */
